<?php
namespace Elementor;

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

class timeline_awesome_post_block extends Widget_Base {

	public function get_name() {
		return 'timeline_awesome-post-block';
	}

	public function get_title() {
		return __( 'Timelines', 'timeline-awesome' );
	}

	public function get_icon() {
		return 'eicon-post-list';
	}

	public function get_categories() {
		return [ 'timeline_awesome-general-category' ];
	}

	protected function _register_controls() {
		/*-----------------------------------------------------------------------------------
			POST BLOCK INDEX
			1. POST SETTING
		-----------------------------------------------------------------------------------*/

		/*-----------------------------------------------------------------------------------*/
		/*  1. POST SETTING
		/*-----------------------------------------------------------------------------------*/
		$this->start_controls_section(
			'section_timeline_awesome_post_block_post_setting',
			[
				'label' => __( 'Post Setting', 'timeline-awesome' ),
			]
		);

		$this->add_control(
			'select_timeline',
			[
				'label' => __( 'Select Timeline', 'timeline-awesome' ),
				'type' => \Elementor\Controls_Manager::SELECT,
				'default' => 'date',
				'options' => select_timeline_post(),
				'description' => __( 'Select post order by (default to latest post).', 'timeline-awesome' ),
			]
		);

		$this->end_controls_section();
		/*-----------------------------------------------------------------------------------
			end of post block post setting
		-----------------------------------------------------------------------------------*/

		$this->start_controls_section(
		'section_timeline_awesome_block_setting',
			[
				'label' => __( 'Title', 'timeline-awesome' ),
				'tab' => Controls_Manager::TAB_STYLE,
			]
		);

		$this->add_group_control(
			Group_Control_Typography::get_type(),
			[
				'name' => 'typhography_timeline_title_typography',
				'label' => __( 'Timeline Title Typography', 'timeline-awesome' ),
				'selector' => '{{WRAPPER}} .timeline-title, {{WRAPPER}} .vertical-basic-timeline .timeline-title, {{WRAPPER}} .horizontal-basic-timeline .timeline-title, {{WRAPPER}} #vertical-basic .timeline h3.timeline-title, {{WRAPPER}} #timeline-horizontal-10 .periods-container section .title, {{WRAPPER}} #timeline-horizontal-4 .timeline-4-content-inner .timeline-title',
			]
		);

		$this->add_group_control(
			Group_Control_Typography::get_type(),
			[
				'name' => 'typhography_timeline_content_typography',
				'label' => __( 'Timeline Content Typography', 'timeline-awesome' ),
				'selector' => '{{WRAPPER}}, {{WRAPPER}} .timeline-text p, {{WRAPPER}} .timeline-text span, {{WRAPPER}} .timeline-text a, {{WRAPPER}} .timeline-text li, {{WRAPPER}} .timeline-text, {{WRAPPER}} .vertical-basic-timeline .timeline-text, {{WRAPPER}} .horizontal-basic-timeline .timeline-text, {{WRAPPER}} #vertical-basic .timeline-content p',
			]
		);

		$this->add_group_control(
			Group_Control_Typography::get_type(),
			[
				'name' => 'typhography_timeline_date_typography',
				'label' => __( 'Timeline Date Typography', 'timeline-awesome' ),
				'selector' => '{{WRAPPER}} .timeline-info, {{WRAPPER}} .vertical-basic-timeline .timeline-info, {{WRAPPER}} .horizontal-basic-timeline .timeline-info, {{WRAPPER}} #vertical-basic .timeline-info, {{WRAPPER}} #timeline-horizontal-4 .tl-nav li, {{WRAPPER}} #timeline-horizontal-10 .periods-container section .year',
			]
		);

	}

	protected function render() {

		$instance = $this->get_settings();

		/*-----------------------------------------------------------------------------------*/
		/*  VARIABLES LIST
		/*-----------------------------------------------------------------------------------*/

		/* POST SETTING VARIBALES */
		$select_timeline 			= ! empty( $instance['select_timeline'] ) ? $instance['select_timeline'] : '';


		/* end of variables list */


		/*-----------------------------------------------------------------------------------*/
		/*  THE CONDITIONAL AREA
		/*-----------------------------------------------------------------------------------*/

		include ( plugin_dir_path(__FILE__).'tpl/timelines-block.php' );

		/*-----------------------------------------------------------------------------------
		  end of conditional end of post block.
		-----------------------------------------------------------------------------------*/

		?>

		<?php

	}

	protected function content_template() {}

	public function render_plain_content( $instance = [] ) {}

}

Plugin::instance()->widgets_manager->register_widget_type( new timeline_awesome_post_block() );