<?php
$timelines = carbon_get_post_meta( get_the_ID(), 'timeline_items' );
?>
<div class="horizontal-basic-timeline">
	<div class="timeline-content timeline-post-<?php echo esc_attr(get_the_ID()); ?>" id="timeline-horizontal-4">
		<div class="tl-4-wrapper">
			<ul class="timeline-horizontal-4">
				<?php foreach ( $timelines as $timeline ) { ?>
				<li class="tl-4-item" data-year="<?php echo esc_attr($timeline['timeline_date']); ?>">
					<div class="tl-image">
						<?php echo wp_get_attachment_image( $timeline['timeline_item_img'], 'full' ); ?>
					</div>
					 <div class="timeline-4-content">
					 	<span class="timeline-info"><?php echo esc_html($timeline['timeline_item_full_date']); ?></span>
						<h3 class="title timeline-title"><?php echo esc_html($timeline['timeline_item_title']); ?></h3>
						<div class="tl-description">
							<p class="timeline-text"><?php echo wp_specialchars_decode($timeline['timeline_item_content']); ?></p>
						</div>
					 </div>
				</li>
				<?php } ?>
			</ul>
		</div>
	</div>
</div>
<script>
jQuery(document).ready(function($){
	/*** Detect the browser's prefixes ***/

	if (document.addEventListener) {
	  // Only IE9+ support this ;)
	  // http://davidwalsh.name/vendor-prefix
	  // Can't use it in IE8- as it brakes the page...
	  	var isPrefixed = (function () {
		    var styles = window.getComputedStyle(document.documentElement, ""),
		      	pre = (Array.prototype.slice
		        .call(styles)
		        .join("")
		        .match(/-(moz|webkit|ms)-/) ||
		        (styles.OLink === "" && ["", "o"]))[1],
		      	dom = "WebKit|Moz|MS|O".match(new RegExp("(" + pre + ")", "i"))[1];
		    	return {
			      	dom: dom,
			      	lowercase: pre,
			      	css: "-" + pre + "-",
			      	js: pre[0].toUpperCase() + pre.substr(1)
			    };
	  	})();

	  	// Deals with prefixes
	  	var prefix = isPrefixed.css;
	} else {
	  	var prefix = "";
	}

	/*** Slides ***/
	var currentSlide = 0,
	  	totalSlides = $(".tl-4-item").length - 1;

	// Creates the navigation
	$(".timeline-horizontal-4").after(
	  	"<div class='tl-nav-wrapper'><ul class='tl-nav'></ul></div><a href='#00' class='tl-4-items-arrow-left'><i class='fa fa-chevron-left'></i></a><a href='#00' class='tl-4-items-arrow-right'><i class='fa fa-chevron-right'></i></a>"
	);
	$(".timeline-4-content").wrapInner("<div class='timeline-4-content-inner'></div>");

	// Cicle through items and creates the nav
	$(".tl-4-item").each(function (i) {
	  	var year = $(".tl-4-item:eq(" + i + ")").data("year");
	  	$(".tl-nav").append("<li><div>" + year + "</div></li>");

	  	// Click handlers
	  	$(".tl-nav li:eq(" + i + ")").click(function () {
		    if (!$(".tl-4-item:eq(" + i + ")").hasClass("tl-active")) {
		      	// Activates the item
		      	$(".tl-4-item").removeClass("tl-active");
		      	$(".tl-4-item:eq(" + i + ")").addClass("tl-active");
		      	currentSlide = i;

		      	// Activates the item nav
		      	$(".tl-nav li").removeClass("tl-active");
		      	$(".tl-nav li:eq(" + i + ")").addClass("tl-active");
		    }
	  	});
	});

	// Activates the first slide
	$(".tl-4-item:first, .tl-nav li:first").addClass("tl-active");

	// Slide's arrows click handlers
	$(".tl-4-items-arrow-left").on("click", function () {
	  	if (currentSlide > 0) {
		    currentSlide--;

		    // Activates the previous item
		    $(".tl-4-item").removeClass("tl-active");
		    $(".tl-4-item:eq(" + currentSlide + ")").addClass("tl-active");

		    // Activates the previous item nav
		    $(".tl-nav li").removeClass("tl-active");
		    $(".tl-nav li:eq(" + currentSlide + ")").addClass("tl-active");
	  	}
	});

	$(".tl-4-items-arrow-right").on("click", function () {
	  	if (currentSlide < totalSlides) {
		    currentSlide++;

		    // Activates the next item
		    $(".tl-4-item").removeClass("tl-active");
		    $(".tl-4-item:eq(" + currentSlide + ")").addClass("tl-active");

		    // Activates the next item nav
		    $(".tl-nav li").removeClass("tl-active");
		    $(".tl-nav li:eq(" + currentSlide + ")").addClass("tl-active");
	  	}
	});

	var navItemWidth = 100 / $(".tl-nav li").length + 5;
	//$(".tl-nav li").css('width', navItemWidth + '%');

	/*** Nav ***/
	// The nav's width
	var navWidth = $(".tl-nav li").outerWidth(true) * $(".tl-nav li").length + 36;
	$(".tl-nav").width(navWidth);

	// The nav's arrows
	$(".tl-nav-wrapper").append("<a href='#leftnav' class='tl-nav-arrow-left'></a><a href='#nextnav' class='tl-nav-arrow-right'></a>");

	/*** The timeline's height ***/
	var vpHeight = $(window).height();
	var tlHeight = vpHeight - $(".tl-nav-wrapper").outerHeight(true) - 26;
	$(".tl-4-wrapper").height(vpHeight);
	$(".tl-4-item").css("max-height", tlHeight);
	$(".tl-4-item").height(tlHeight);

	/*** Nav's navigation... ***/
	var navTranslation = 0;
	var navLimit = (navWidth - $(".tl-nav-wrapper").outerWidth(true) + 20) * -1;

	// To the left
	$(".tl-nav-arrow-left").on("click", function() {
	  if(navTranslation < 0) {
	    navTranslation = navTranslation + 86;
	    $(".tl-nav").css(prefix + "transform", "translateX(" + navTranslation + "px)");
	  }
	});

	// To the right
	$(".tl-nav-arrow-right").on("click", function() {
	  if(navTranslation >= navLimit) {
	    navTranslation = navTranslation - 86;
	    $(".tl-nav").css(prefix + "transform", "translateX(" + navTranslation + "px)");
	  }
	});

});
</script>